// 002 u_dbx4_02_dbx4_connect
// 18 sep 2007

// -- (C) Felix John COLIBRI 2007
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_dbx4_02_dbx4_connect;
interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, WideStrings, StdCtrls, ExtCtrls, ComCtrls, FMTBcd, Grids, DBGrids,
  DB, DBClient, Provider, SqlExpr;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Splitter1: TSplitter;
    PageControl1: TPageControl;
    log_: TTabSheet;
    Memo1: TMemo;
    Panel2: TPanel;
    exit_: TButton;
    clear_: TButton;
    PageControl2: TPageControl;
    connection_: TTabSheet;
    connection_listbox_: TListBox;
    exec_: TTabSheet;
    Panel3: TPanel;
    disconnect_: TButton;
    Panel4: TPanel;
    connect__: TButton;
    sqlconnection_: TTabSheet;
    SQLConnection1: TSQLConnection;
    SQLDataSet1: TSQLDataSet;
    DataSetProvider1: TDataSetProvider;
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    SQLConnection3: TSQLConnection;
    SQLDataSet3: TSQLDataSet;
    DBX_EMPLOYEE_JDS: TSQLConnection;
    SQLDataSet2: TSQLDataSet;
    Panel5: TPanel;
    display_connection_names_: TButton;
    Panel6: TPanel;
    select_from_country_: TButton;
    Panel7: TPanel;
    prepare_: TButton;
    Panel8: TPanel;
    do_execute_: TCheckBox;
    insert_into_: TButton;
    create_table__: TButton;
    Panel9: TPanel;
    parameter_edit_: TEdit;
    execute_: TButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure connect__Click(Sender: TObject);
    procedure select_from_country_Click(Sender: TObject);
    procedure insert_into_Click(Sender: TObject);
    procedure disconnect_Click(Sender: TObject);
    procedure display_connection_names_Click(Sender: TObject);
    procedure connection_listbox_Click(Sender: TObject);
    procedure create_table__Click(Sender: TObject);
    procedure prepare_Click(Sender: TObject);
    procedure execute_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses Registry  // get ini path+ file names
      , IniFiles // read the .INI
      , DbxCommon
      , DBByteBuffer, StrUtils
      , u_c_display
      ;

    {$R *.dfm}

  
    const k_connection_name= 'EMPLOYEE_7';

    var g_connection_name: String= k_connection_name;
        g_connection_name_index: Integer= 0;

        g_c_dbx_connection: tDbxConnection= Nil;

    function f_w_connection_name: WideString;
      begin
        Result:= g_connection_name;
      end; // f_w_connection_name

    function f_s_connection_name: String;
      begin
        Result:= g_connection_name;
      end; // f_w_connection_name

    // -- form1 methods

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        Caption:= g_connection_name;
        display_connection_names_Click(Nil);        
        with connection_listbox_ do
          ItemIndex:= Items.IndexOf(g_connection_name);
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    // -- our events

    procedure TForm1.display_connection_names_Click(Sender: TObject);
      begin
        TDBXConnectionFactory.GetConnectionFactory.GetConnectionItems(connection_listbox_.Items);
        g_connection_name_index:= connection_listbox_.Items.IndexOf(k_connection_name);
      end; // display_connection_names_Click

    procedure TForm1.connection_listbox_Click(Sender: TObject);
      begin
        with connection_listbox_ do
          g_connection_name:= Items[ItemIndex];
        Caption:= g_connection_name;
      end; // connection_listbox_Click

    // -- connect

    procedure TForm1.connect__Click(Sender: TObject);
      var l_c_dbx_connection_factory: TDBXConnectionFactory;
          l_c_dbx_connection_properties: TDBXProperties;
      begin
        display_line;
        display('> connect__Click');
        l_c_dbx_connection_factory:= TDBXConnectionFactory.GetConnectionFactory;

        l_c_dbx_connection_properties:= l_c_dbx_connection_factory.GetConnectionProperties(f_w_connection_name);
        display(l_c_dbx_connection_properties.Values[TDBXPropertyNames.UserName]);
        display(l_c_dbx_connection_properties.Values[TDBXPropertyNames.Password]);

(*
        g_c_dbx_connection:= l_c_dbx_connection_factory.
            GetConnection(f_s_connection_name, 'sysdba', 'masterkey');
*)
        g_c_dbx_connection:= l_c_dbx_connection_factory.
            GetConnection(l_c_dbx_connection_properties);
(*
            GetConnection(f_s_connection_name, // l_c_dbx_connection_properties,
            l_c_dbx_connection_properties.Values[TDBXPropertyNames.UserName], l_c_dbx_connection_properties.Values[TDBXPropertyNames.Password] );
*)
        // -- NO
        // g_c_dbx_connection.Connected Open;
        display('< connect__Click');
      end; // connect_Click

    procedure read_table(p_sql_request: WideString);
      var l_c_dbx_transaction: TDBXTransaction;
          l_c_dbx_command: TDBXCommand;
          l_c_dbx_reader: TDBXReader;

          l_row_string: String;
          l_column_index: Integer;
      begin
        l_c_dbx_transaction:= g_c_dbx_connection.BeginTransaction();
        l_c_dbx_command:= g_c_dbx_connection.CreateCommand;
        l_c_dbx_reader:= Nil;

        try
          l_c_dbx_command.Text:= p_sql_request;
          l_c_dbx_reader:= l_c_dbx_command.ExecuteQuery;

          // -- display in the Memo
          while l_c_dbx_reader.Next do
          begin
            l_row_string:= '';

            for l_column_index:= 0 to l_c_dbx_reader.ColumnCount - 1 do
            begin
              if l_row_string<> ''
                then l_row_string:= l_row_string+ ' | ';
              l_row_string:= l_row_string+ l_c_dbx_reader.Value[l_column_index].GetAnsiString; //   .GetString;
            end; // for l_column_index
            display(l_row_string);
          end; // while l_c_dbx_reader.Next

        finally
          g_c_dbx_connection.CommitFreeAndNil(l_c_dbx_transaction);
          l_c_dbx_command.Free;
          l_c_dbx_reader.Free;
        end;  // try ... finally
      end; // read_table

    procedure TForm1.select_from_country_Click(Sender: TObject);
      begin
        display_line;
        display('> open_table');

        read_table('SELECT * FROM country');

        display('< select_from_country_Click');
      end; // open_table_Click

    const
          k_parametrized_select=
            'SELECT *'
         +  '  FROM country'
         +  '  WHERE currency= ?';

    var g_c_dbx_parametrized_command: tDbxCommand= Nil;
        g_c_dbx_parameter: TDBXParameter;

    procedure TForm1.prepare_Click(Sender: TObject);
      begin
        display_line;
        display('> prepare');

        g_c_dbx_parametrized_command:= g_c_dbx_connection.CreateCommand;
        g_c_dbx_parametrized_command.Text:= k_parametrized_select;
        // -- NO: the parameters have not been created yet
        // g_c_dbx_parametrized_command.Prepare;

        // -- create a new parameter
        g_c_dbx_parameter:= g_c_dbx_parametrized_command.CreateParameter;
        // -- fill the parameter information

        with g_c_dbx_parameter do
        begin
          DataType:= TDBXDataTypes.AnsiStringType;
(*
          Size:= 10;
          // Size               := 0; //For in params size can be 0? otherwise use TParam.GetDataSize
          ChildPosition:= 0;  //ChildPosArray[I] <-- ADT or Array field type this will play a role only oracle?
          // SubType            := iSubType;
          // Precision          := Column.Precision;
          // Scale              := Column.Scale;

          if DataType = TDBXDataTypes.UnknownType
            then display_bug_stop('unk');
*)
        end; // with g_c_dbx_parameter

        g_c_dbx_parametrized_command.Parameters.AddParameter(g_c_dbx_parameter);
        g_c_dbx_parametrized_command.Prepare;

        display('< prepare');
      end; // prepare_Click

    procedure TForm1.execute_Click(Sender: TObject);
      var l_c_dbx_reader: TDBXReader;
          l_row_string: String;
          l_column_index: Integer;
      var l_c_dbx_transaction: TDBXTransaction;
      begin
        display('> execute '+ IntToStr(g_c_dbx_parametrized_command.Parameters.Count));
        // -- set the value of the parameter
        g_c_dbx_parameter.Value.SetAnsiString(parameter_edit_.Text);

        Try
          l_c_dbx_transaction:= g_c_dbx_connection.BeginTransaction();
          try
            // -- IF has called "Prepare"
            // -- exception in DbxCommon | TDBXCommand.SetParameters
            l_c_dbx_reader:= g_c_dbx_parametrized_command.ExecuteQuery;
          Except
            on e: Exception do
              display_bug_stop(e.Message);
          end;

          // -- display in the Memo
          while l_c_dbx_reader.Next do
          begin
            l_row_string:= '';

            for l_column_index:= 0 to l_c_dbx_reader.ColumnCount - 1 do
            begin
              if l_row_string<> ''
                then l_row_string:= l_row_string+ ' | ';
              l_row_string:= l_row_string+ l_c_dbx_reader.Value[l_column_index].GetAnsiString; //   .GetString;
            end; // for l_column_index
            display(l_row_string);
          end; // while l_c_dbx_reader.Next

        finally
          g_c_dbx_connection.CommitFreeAndNil(l_c_dbx_transaction);
          l_c_dbx_reader.Free;
        end;
        display('< execute');
      end; // execute_Click

    // -- CREATE, INSERT, UPDATE

    procedure execute_sql_statement(p_sql_request: WideString);
      var l_c_dbx_database_metadata: TDBXDatabaseMetaData;
          l_c_dbx_transaction: TDBXTransaction;
          l_c_dbx_command: TDBXCommand;
      begin
        display(p_sql_request);
        if not Form1.do_execute_.Checked
          then Exit;
        if g_c_dbx_connection= Nil
          then Exit;

        if g_c_dbx_connection.IsOpen
          then
            begin
              display('is_open');
              l_c_dbx_command:= Nil;
              try
                l_c_dbx_database_metadata:= g_c_dbx_connection.DatabaseMetaData;
                if l_c_dbx_database_metadata.SupportsTransactions
                  then l_c_dbx_transaction:= g_c_dbx_connection.BeginTransaction();

                try
                  l_c_dbx_command:= g_c_dbx_connection.CreateCommand;
                  l_c_dbx_command.Text:= p_sql_request;
                  l_c_dbx_command.ExecuteQuery;
                  if l_c_dbx_database_metadata.SupportsTransactions
                    then g_c_dbx_connection.CommitFreeAndNil(l_c_dbx_transaction);
                  display('ok_executed');
                finally
                  if l_c_dbx_database_metadata.SupportsTransactions
                    then g_c_dbx_connection.RollbackIncompleteFreeAndNil(l_c_dbx_transaction);

                  if Assigned(l_c_dbx_command)
                    then l_c_dbx_command.Free;
                end;
              except
                on E: Exception do
                  display_bug_stop('exception '+ e.Message);
              end; // try except
            end // IsOpen
          else display_bug_stop('not_open')  ;
      end; // execute_sql_statement

    procedure TForm1.insert_into_Click(Sender: TObject);
      const k_insert_request= 'INSERT INTO %s (%s, %s) VALUES (%s, %s)';
      var l_insert_request: String;
      begin
        display_line;
        display('> insert_into');

        l_insert_request:= Format(k_insert_request,
            ['COUNTRY', 'country', 'currency', QuotedStr('Europe'), QuotedStr('Euro')]);
        execute_sql_statement(l_insert_request);

        display('< insert_into');
      end; // insert_into_Click

    procedure TForm1.create_table__Click(Sender: TObject);
      var l_create_table: String;
      begin
        l_create_table:=
             'CREATE TABLE training1'
          +  '  (training_id Integer, training_name CHAR(15))';
        execute_sql_statement(l_create_table);
      end; // create_table__Click

    procedure TForm1.disconnect_Click(Sender: TObject);
      begin
        FreeAndNil(g_c_dbx_connection);
      end; // disconnect_Click

    end.
